=== third_party/popt/wscript ===
#!/usr/bin/env python

import Options

def configure(conf):
    conf.CHECK_HEADERS('float.h')

    if conf.CHECK_POPT():
        conf.define('USING_SYSTEM_POPT', 1)

def build(bld):
    if bld.CONFIG_SET('USING_SYSTEM_POPT'):
        return

    bld.SAMBA_LIBRARY('popt',
                      source='findme.c popt.c poptconfig.c popthelp.c poptparse.c',
                      cflags='-DDBL_EPSILON=__DBL_EPSILON__',
                      allow_warnings=True,
                      private_library=True)
