=== debian/changelog ===
ldb (1:1.1.24-0ubuntu0.14.04.2) trusty-security; urgency=medium

  * SECURITY UPDATE: Out of bound read in ldb_wildcard_compare
    - debian/patches/CVE-2019-3824-1.patch: fix length.
    - debian/patches/CVE-2019-3824-2.patch: add extra comments.
    - debian/patches/CVE-2019-3824-3.patch: improve code style.
    - debian/patches/CVE-2019-3824-4.patch: use talloc_zero.
    - debian/patches/CVE-2019-3824-5.patch: check tree operation.
    - debian/patches/CVE-2019-3824-6.patch: fix end of data check.
    - CVE-2019-3824

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 25 Feb 2019 08:27:10 -0500

ldb (1:1.1.24-0ubuntu0.14.04.1) trusty-security; urgency=medium

  * Updated to upstream 1.1.24 as required by Samba security update.
    - debian/patches/01_exclude_symbols: removed, upstream.
    - debian/patches/CVE-2015-3223.patch: removed, upstream.
    - debian/patches/CVE-2015-5330.patch: removed, upstream.
    - debian/rules: adjusted location of files to be cleaned.
    - debian/*.symbols: updated for new version.
    - debian/control: bump tdb Build-Depends.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 05 Apr 2016 13:14:18 -0400

ldb (1:1.1.16-1ubuntu0.1) trusty-security; urgency=medium

  * SECURITY UPDATE: denial of service in ldb_wildcard_compare function
    - debian/patches/CVE-2015-3223.patch: handle empty strings and
      embedded zeros in lib/ldb/common/ldb_match.c.
    - CVE-2015-3223
  * SECURITY UPDATE: information leak via incorrect string length handling
    - debian/patches/CVE-2015-5330.patch: fix string length handling in
      lib/ldb/common/ldb_dn.c.
    - CVE-2015-5330

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 04 Jan 2016 10:14:35 -0500
