=== debian/watch ===
version=3
http://ftp.samba.org/pub/ldb/ldb-(.+).tar.gz
